/*
 * Created on 3 mai 2005
 */
package com.medias.megapoli.struts.actions;

import com.medias.megapoli.struts.forms.CapteursForm;
import com.medias.megapoli.trade.ListeCapteursAdapter;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author pignot
 * 
 * Action déclenchée au moment d'afficher la liste des capteurs
 */
public class CapteursAccessAction extends Action {
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws ServletException {
        ListeCapteursAdapter adapter = new ListeCapteursAdapter();

        String target = "failure";
        ActionErrors errors = new ActionErrors();

        if (form != null) {
            CapteursForm cform = (CapteursForm) form;
            try {
                // A partir de la base de données ...
                adapter.loadCapteursFromDatabase(cform);
                target = "success";
            } catch (Exception e) {
                System.out.println("exception_CapteursAccessAction");
                errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError(
                        "errors.access.requete.fail"));
                e.printStackTrace();
            }
        }
        if (!errors.isEmpty()) {
            saveErrors(request, errors);
        }
        return mapping.findForward(target);
    }
}