/*
 * Created on 3 mai 2005
 */
package com.medias.megapoli.struts.actions;


import javax.servlet.ServletException;
import javax.servlet.http.*;

import org.apache.struts.action.*;
import com.medias.megapoli.struts.forms.DatasForm;
import com.medias.megapoli.trade.ListeCapteursAdapter;
import com.medias.megapoli.trade.ListeJeuxAdapter;
import com.medias.megapoli.trade.ListeParametresAdapter;
import com.medias.megapoli.trade.ListePlateformesAdapter;
import com.medias.megapoli.trade.MesureAdapter;

/**
 * @author pignot
 * 
 * Action déclenchée au moment d'afficher l'interface d'exctraction de données
 */
public class DataAccessAction extends Action {
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws ServletException {
        String target = "failure";
        ActionErrors errors = new ActionErrors();
        if (form != null) {
            DatasForm dform = (DatasForm) form;
            try {
            	// chargement de la liste des plates-formes
                ListePlateformesAdapter pAdapter = new ListePlateformesAdapter();
            	pAdapter.loadPlateformesFromDatabase(dform);
                // Chargement de la liste des jeux
                ListeJeuxAdapter jAdapter = new ListeJeuxAdapter();
                jAdapter.loadJeuxFromDatabase(dform);
                // Chargement de la liste des capteurs
                ListeCapteursAdapter cAdapter = new ListeCapteursAdapter();
                cAdapter.loadCapteursFromDatabase(dform);
                // Chargement de la liste des paramètres
                ListeParametresAdapter parAdapter = new ListeParametresAdapter();
                parAdapter.loadParametresFromDatabase(dform);
                MesureAdapter mAdapter = new MesureAdapter();
                mAdapter.loadDatesFromDatabase(dform);
                mAdapter.loadLocsFromDatabase(dform);
                //dform.setLatMin("-90");
                //dform.setLatMax("90");
                //dform.setLonMin("-180");
                //dform.setLonMax("180");
                target = "success";
            } catch (Exception e) {
                System.out.println("exception_DataAccessAction");
                errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.access.requete.fail"));
                e.printStackTrace();
            }
        }
        if (!errors.isEmpty()) {
            saveErrors(request, errors);
        }
        return mapping.findForward(target);
    }
}