/*
 * Created on 3 mai 2005
 */
package com.medias.megapoli.struts.actions;

import com.medias.annuaire.Personne;
import com.medias.megapoli.struts.forms.DatasForm;
import com.medias.megapoli.utils.Requete;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.jdom.Document;
import org.jdom.output.XMLOutputter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

/**
 * @author pignot
 * 
 * Action déclenchée au moment de lancer l'extraction
 */
public class DataExtractAction extends Action {
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws ServletException {
        String target = "success";
        if (this.isCancelled(request)) {
			target = "cancel";
	        return mapping.findForward(target);
        }

        ActionErrors errors = new ActionErrors();
        if (form != null) {
        	DatasForm dform = (DatasForm) form;
        	XMLOutputter outXml = new XMLOutputter();
        	Personne pers = (Personne)request.getSession().getAttribute("SES_USER");
        	if (pers == null) {
        		target = "cancel";
    	        return mapping.findForward(target);
        	}
        	Document docXml = Requete.toXml( dform, pers );
        	String requete = outXml.outputString(docXml);
        	try {
				String encoded = "requete="+URLEncoder.encode(requete,"UTF-8");
				// Configuration de l'URL
				String urlCGIStr = (String) request.getSession().getServletContext().getAttribute("APP_CGI");
				URL urlCGI = new URL(urlCGIStr);
				URLConnection conn = urlCGI.openConnection();
				conn.setDoOutput(true);
				conn.setUseCaches(false);
				conn.setRequestProperty("content-type", "application/x-www-form-urlencoded");
				// Envoi de la requête
				DataOutputStream out = new DataOutputStream(conn.getOutputStream());
				out.writeBytes(encoded);
				out.flush();
				out.close();
				
				// Réponse du CGI
				BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
				String aLine;
				while ((aLine = in.readLine()) != null) {
					if (aLine.length() == 0) continue;
					if (aLine.startsWith("1")) {
						System.err.println("ERROR :"+aLine);
					} else	System.out.println("REPONSE :"+aLine);

				}
			} catch (Exception e) {
				e.printStackTrace();
			}
        	
        }
        if (!errors.isEmpty()) {
            saveErrors(request, errors);
        }
        return mapping.findForward(target);
    }
}