package com.medias.megapoli.struts.actions;

import java.io.File;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import com.medias.annuaire.Annuaire;
import com.medias.xml.hierarchie.Hierarchie;
import com.medias.megapoli.struts.forms.DeleteForm;
import com.medias.megapoli.utils.MegapoliInitialisation;
import com.medias.Context;

/**
 * @author combaz
 *
 * Created on 23 févr. 2005
 */
public class DeleteSetAction extends Action {
	public ActionForward execute (ActionMapping mapping,ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
	        throws ServletException {
		String target = "failure";
		ActionErrors errors = new ActionErrors();
		
		if(this.isCancelled(request))
			target = "cancel";

		else if(form!=null) {
			DeleteForm df = (DeleteForm) form;
			String setPath = df.getPath();
			String setName = df.getName();
			Hierarchie tree = (Hierarchie) request.getSession().getServletContext().getAttribute("APP_UPLOADTREE");
			Annuaire annu = (Annuaire) request.getSession().getServletContext().getAttribute("APP_ANNUAIRE");
			try {
				tree.deleteFolder(setPath);
				annu.deleteSet(setName);
				File pathImg = new File(MegapoliInitialisation.pathImages+"/"+setPath);
				if (pathImg.exists()) {
					File[] imgs =pathImg.listFiles();
					for (File img: imgs) img.delete();
					pathImg.delete();
				}
				target="success";
			}
			catch(Exception e) {
				e.printStackTrace();
				errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.deleteSet.failed",Context.getWebmaster(request)));
			}
		}

		if(!errors.isEmpty()){
			saveErrors(request, errors);
		}

		return mapping.findForward(target);
	}

}
