/*
 * Created on 3 mai 2005
 */
package com.medias.megapoli.struts.actions;

import javax.servlet.ServletException;
import javax.servlet.http.*;

import org.apache.struts.action.*;
import com.medias.megapoli.struts.forms.FichiersForm;
import com.medias.megapoli.trade.ListeFichiersAdapter;

/**
 * @author pignot
 * 
 * Action déclenchée au moment d'afficher la liste des fichiers d'un jeu
 */
public class FichiersAccessAction extends Action {
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)
            throws ServletException {
        ListeFichiersAdapter adapter = new ListeFichiersAdapter();
    	int idJeu = Integer.parseInt(request.getParameter("idJeu"));
        String target = "failure";
        ActionErrors errors = new ActionErrors();
        if (form != null) {
            FichiersForm fform = (FichiersForm) form;
            fform.setIdJeu(idJeu);
            try {
                // A partir de la base de données ...
                adapter.loadFichiersFromDatabase(fform, idJeu);
                target = "success";
            } catch (Exception e) {
                System.out.println("exception_FichiersAccessAction");
                errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.access.requete.fail"));
                e.printStackTrace();
            }
        }
        if (!errors.isEmpty()) {
            saveErrors(request, errors);
        }
        return mapping.findForward(target);
    }
}