package com.medias.megapoli.struts.actions;

import com.medias.annuaire.Personne;
import com.medias.xml.metadata.Metadata;
import com.medias.megapoli.struts.forms.MetadataForm;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author combaz
 * Created on 15 févr. 2005
 */
public class LoadMetadataAction extends Action {
	public ActionForward execute (ActionMapping mapping,ActionForm form,
	                              HttpServletRequest request, 
	                              HttpServletResponse response)
	        throws ServletException {
		String target = "failure";
		String path = request.getParameter ("metadataUri");
		ActionErrors errors = new ActionErrors ();
	
		if (form != null) {
			MetadataForm mform = (MetadataForm)form;		
			if ((path != null) && (path.length () != 0)) {
				try {
					// On charge la métadonnée...
					Metadata meta = new Metadata (path);
					mform.setMetadata (meta);

					// On vérifie les droits de l'utilisateur sur la métadonnée
					Personne user = (Personne) request.getSession ().getAttribute ("SES_USER");
					String rights = "read";
					if((user.getRoles ().equals ("coordinateur")) || (user.hasSet (meta.getPres ().getNom ())))
						rights = "write";
					request.getSession ().setAttribute ("SES_RIGHTS", rights);
					
					target = "success";
				}
				catch (Exception e) {
					System.out.println ("exception_LoadMetadataAction");
					errors.add (ActionErrors.GLOBAL_MESSAGE, new ActionError ("errors.upload.metadata.notfound"));
					
					e.printStackTrace ();
				}
			}
		}
		
		if(!errors.isEmpty ()){
			saveErrors (request, errors);
		}
		
		return mapping.findForward (target);
	}
}
