package com.medias.megapoli.struts.actions;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import com.medias.annuaire.Annuaire;
import com.medias.annuaire.Personne;
import com.medias.megapoli.struts.forms.LogonForm;
import com.medias.Context;


/**
 * @author combaz
 *
 * Created on 22 févr. 2005
 */
public class LogonAction extends Action {
    
	public ActionForward execute (ActionMapping mapping, 
	                              ActionForm form,
	                              HttpServletRequest request, 
	                              HttpServletResponse response)
	        throws ServletException {
	    
		String target = "input";
		ActionErrors errors = new ActionErrors ();
				
		if (this.isCancelled (request))
			target = "cancel";

		else if (form != null) {
			LogonForm lform = (LogonForm)form;
			String login = lform.getLogin().trim();
			String pwd = lform.getPwd().trim();
			
			Annuaire annu = (Annuaire) request.getSession ().getServletContext ().getAttribute ("APP_ANNUAIRE");
			try {
				Personne pers = annu.getPersonne (login, pwd);
				if (pers == null)
					errors.add (ActionErrors.GLOBAL_MESSAGE, new ActionError ("errors.logon.notFound",Context.getWebmaster(request)));
				else {
					request.getSession().setAttribute("SES_USER", pers);
					target = lform.getSource();
//					System.out.println ("TARGET : " + target);
				}
			}
			catch (Exception e) {
				System.out.println ("exception_logonAction");
				e.printStackTrace ();
				errors.add (ActionErrors.GLOBAL_MESSAGE, new ActionError ("errors.logon.failed",Context.getWebmaster(request)));
			}
			
			lform.setFieldsToNull ();
		}
		
		if(!errors.isEmpty ()){
			saveErrors (request, errors);
			target = "login";
//			System.out.println ("TARGET : " + target);
		}
		
		return (mapping.findForward (target));
		
	}
	
}
