/*
 * Created on 10 févr. 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.medias.megapoli.struts.actions;

import java.io.FileInputStream;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.medias.annuaire.Annuaire;
import com.medias.annuaire.Personne;
import com.medias.xml.hierarchie.Hierarchie;
import com.medias.xml.metadata.Metadata;
import com.medias.xml.metadata.Presentation;
import com.medias.megapoli.struts.forms.MetadataForm;
import com.medias.Context;
import com.medias.mail.Mail;
import com.medias.mail.MailFactory;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

/**
 * @author combaz
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NewSetAction extends Action {
	
	public ActionForward execute(ActionMapping mapping,ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
	        throws ServletException {
		String target = "failure";
		
		ActionErrors errors = new ActionErrors();
		ActionMessages mess = new ActionMessages();
		
		if(this.isCancelled(request))
			target = "cancel";
		
		else if(form!=null) {
			MetadataForm mform = (MetadataForm)form;
			Metadata metadata = mform.getMetadata();
			
			//on récupère le message indiquant le traitement attendu (ajout ou suppression d'un contact)
			String message = mform.getMessText();
			HashMap<String, String> map = (HashMap<String, String>)this.getKeyMethodMap();
			String methodName = map.get(message);

			//et si le message en question est non nul, on exécute la méthode correspondante.
			if(methodName!=null) {
				try {
					Class<?>[] paramClasses = null;
					Object[] params = null;
					if(methodName.startsWith("remove")) {
						paramClasses = new Class[1];
						Integer idx = mform.getMessIdx();
						paramClasses[0] = idx.getClass();
						params = new Object[1];
						params[0] = idx;
					}
					
					Presentation pres = metadata.getPres();
					Method method = pres.getClass().getMethod(methodName, paramClasses);
					method.invoke(pres,params);
					target="input";
				}
				catch(Exception e) {
					System.out.println ("exception2_newSetAction");
					errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.newSet.failed",Context.getWebmaster(request)));
					e.printStackTrace();
				}
			}
			
			else {
				Hierarchie tree = (Hierarchie) this.getServlet().getServletContext().getAttribute("APP_UPLOADTREE");
				String setPath = metadata.getRelativePath();

				//Si le jeu n'existe pas encore, on le crée...
				if(!tree.isFolder(setPath)) {
					try {
						//on remet à jour la métadonnée
						switch (metadata.updateContacts()) {
							case Metadata.CONTACT_PI:
								errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.updateMetadata.failed.contact_pi"));
								saveErrors(request, errors);
								target = "failure";
								return mapping.findForward(target);
							case Metadata.CONTACT_TECH:
								errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.updateMetadata.failed.contact_tech"));
								saveErrors(request, errors);
								target = "failure";
								return mapping.findForward(target);
							case Metadata.CONTACT_WRONG:
								errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.updateMetadata.failed.pwd"));
								saveErrors(request, errors);
								target = "failure";
								return mapping.findForward(target);
							default:
						}
						//metadata.updateContacts();
						metadata.createNewSet(tree);
//						metadata.createXmlFile();
						target = "success";
					}
					catch(Exception e) {
						System.out.println ("exception1_newSetAction");
						e.printStackTrace();
						errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.newSet.failed",Context.getWebmaster(request)));
					}
					//on met à jour l'annuaire, au cas où de nouveaux contacts aient été créés...
					Annuaire annu = (Annuaire) this.getServlet().getServletContext().getAttribute("APP_ANNUAIRE");
					try {
						int nbPersAPrevenir = annu.update(metadata, mess);
						if (nbPersAPrevenir != 0)
							mess.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("data.upload.newSet.succeded"));
						else
							mess.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("data.upload.newSet.succeded2"));
						target = "success";
					}
					catch(Exception e) {
						System.out.println ("exception3_newSetAction");
						errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.newSet.updateAnnu.failed",Context.getWebmaster(request)));
						e.printStackTrace();
					}

					//on prépare les mails à envoyer aux contacts
					Personne user = (Personne) request.getSession().getAttribute("SES_USER");
					String exp_nom = user.getPrenom()+" "+user.getNom();
					String exp_mail = user.getMail();
					String webinf = this.getServlet().getServletContext().getRealPath("WEB-INF");
					//on charge le fichier de proprietes
					Properties prop = new Properties ();
					try {
						prop.load (new FileInputStream (webinf + "/megapoli.properties"));
					}
					catch (Exception e) {
						System.out.println ("exception1_megapoliInitialisation");
						e.printStackTrace ();
					}
					mform.initNewSetMails(prop, exp_mail, exp_nom);
					//on remet les messages à zéro,
					mform.initMess();
					//Envoi d'un mail automatique au webmaster
					MailFactory mf = (MailFactory) this.servlet.getServletContext().getAttribute("APP_MAILFACTORY");
					String from = "megapoli_info@obs-mip.fr";
					String to = Context.getWebmaster(request);
					String subject = "[MEGAPOLI] Jeu '"+mform.getMetadata().getPres().getNom()+"' cree";
					Mail mail = new Mail(from, to, null, "", subject);
					try {
						mf.sendMail(mail);
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
				// Sinon, le jeu existe déjà-> erreur
				else {
					errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.newSet.failed2",metadata.getPres().getNom()));
				}

			}			
		}

		if(!errors.isEmpty()){
			saveErrors(request, errors);
			target = "failure";
		}

		if(!mess.isEmpty()){
			saveMessages(request, mess);
		}			
			
		return mapping.findForward(target);
	}
	
	
	protected Map<String, String> getKeyMethodMap() {
	      Map<String, String> map = new HashMap<String, String>();
	      map.put("Ajouter un contact", "addContact");
	      map.put("Add a contact", "addContact");
	      map.put("deletePers", "removeContact");
	      return map;
	  }
}
