package com.medias.megapoli.struts.actions;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import com.medias.annuaire.Personne;
import com.medias.xml.hierarchie.Hierarchie;
import com.medias.megapoli.struts.forms.PrepareTreeForm;


/**
 * @author combaz
 *
 * Created on 24 févr. 2005
 */
public class PrepareTreeAction extends Action {
	public ActionForward execute (ActionMapping mapping,
	                              ActionForm form,
	                              HttpServletRequest request, 
	                              HttpServletResponse response)
	        throws ServletException {
	    
		String 			target 	= "failure";
		ActionErrors 	errors 	= new ActionErrors ();
		String 			path 	= (String)request.getSession ().getServletContext ().getAttribute ("DataDescPathName");
		Hierarchie 		arborescence;
//		Hierarchie tree = (Hierarchie)request.getSession ().getServletContext ().getAttribute ("APP_UPLOADTREE");
		
		if (form != null) {
			PrepareTreeForm pTreeForm = (PrepareTreeForm)form;		
			try {
				// On charge la métadonnée...
			    if (path != null) {
					arborescence = new Hierarchie(path);
					pTreeForm.setHierarchie (arborescence);
					// On vérifie les droits de l'utilisateur sur la métadonnée
					Personne user = (Personne) request.getSession ().getAttribute ("SES_USER");
					if (user == null) {
						target = "login";
					} else {
						String rights = "read";
						if ((user.getRoles ().equals ("coordinateur")))
							rights = "write";
						request.getSession ().setAttribute ("SES_RIGHTS", rights);
	//				tree.createTreeView ();
						target = "success";
					}
			    } else {
			        throw new Exception ("Chemin vers le fichier de description de hierarchie xml introuvable");
			    }
			}
			catch (Exception e) {
				System.out.println ("exception_PrepareTreeAction");
				errors.add (ActionErrors.GLOBAL_MESSAGE, new ActionError ("errors.upload.prepareTree.failed"));
				e.printStackTrace ();
			}
		}
		
		if (!errors.isEmpty ()){
			saveErrors (request, errors);
		}
		
		return mapping.findForward (target);
	}
	
}
