package com.medias.megapoli.struts.actions;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;
import org.apache.struts.upload.FormFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;

import com.medias.xml.hierarchie.Hierarchie;
import com.medias.megapoli.struts.forms.UploadForm;
import com.medias.Context;
import com.medias.mail.Mail;
import com.medias.mail.MailFactory;


/**
 * @author combaz
 * Created on 3 févr. 2005
 * 
 */
public class UploadAction extends Action {
	
	/**
	 * Copie le fichier récupéré par l'UploadForm à l'endroit de l'arborescence qui lui a été attribué,
	 * et répercute ces modifications dans la hiérarchie...
	 * @param mapping Le mapping associé à cette action
	 * @param form Le formulaire (UploadForm) associé à cette action
	 * @param request La requete qui a donné lieu à l'exécution de l'action
	 * @param response La reponse
	 * @return target L'identifiant de la page a afficher a l'issue de l'execution.
	 * @throws ServletException
	 */
	public ActionForward execute(ActionMapping mapping,ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
	        throws ServletException {
		String target = "failure";
		ActionErrors errors = new ActionErrors();
		ActionMessages messages = new ActionMessages();
		
		if(form != null) {
			UploadForm upload = (UploadForm) form;
			String path = upload.getPath();
			FormFile file = upload.getNewFile();
			if((file.getFileSize()!=0) && (path.length()!=0)) {
				Hierarchie dataTree = (Hierarchie)this.getServlet().getServletContext().getAttribute("APP_UPLOADTREE");
				try {
					dataTree.saveFile(path,file);
					//Envoi d'un mail automatique au webmaster
					MailFactory mf = (MailFactory) this.servlet.getServletContext().getAttribute("APP_MAILFACTORY");
					String from = "megapoli_info@obs-mip.fr";
					String to = Context.getWebmaster(request);
					String subject = "[MEGAPOLI] Fichier '"+file.getFileName()+"' depose dans '"+upload.getPath()+"'";
					Mail mail = new Mail(from, to, null, "", subject);
					mf.sendMail(mail);
					target="success";
					messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("data.upload.succeded"));
				}
				catch(Exception e){
					System.out.println ("exception_uploadAction");
					errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.failed"));
					e.printStackTrace();
				}
			}
			else {
				errors.add(ActionErrors.GLOBAL_MESSAGE, new ActionError("errors.upload.file.required"));
			}
		}
		if(!errors.isEmpty()){
			saveErrors(request, errors);
		}
		if(!messages.isEmpty()){
			saveMessages(request, messages);
		}
		
		return (mapping.findForward(target));
	}
	
}