/*
 * Created on 3 mai 2005
 */
package com.medias.megapoli.struts.forms;

import com.medias.DateTime;
import com.medias.Nombre;
import com.medias.annuaire.Personne;
import com.medias.database.objects.Capteur;
import com.medias.database.objects.Jeu;
import com.medias.database.objects.Parametre;
import com.medias.database.objects.Plateforme;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;

/**
 * @author pignot
 *         <p/>
 *         Classe décrivant les objets de la page contenant l'interface
 *         d'extraction
 */
public class DatasForm
        extends ValidatorForm
{

    /**
     *
     */
    private static final long serialVersionUID = 1L;
    private ArrayList<Plateforme> plateformes;
    private ArrayList<Jeu> jeux;
    private ArrayList<Capteur> capteurs;
    private ArrayList<Parametre> parametres;
    private String[] selectPlats;
    private String[] selectJeux;
    private String[] selectCapts;
    private String[] selectParams;
    private String dateDeb;
    private String dateFin;
    private String latMin;
    private String latMax;
    private String lonMin;
    private String lonMax;
    private String dateDebInit;
    private String dateFinInit;
    private String latMinInit;
    private String latMaxInit;
    private String lonMinInit;
    private String lonMaxInit;
    private int nbValeurs;
    private String output;
    private String compression;
    private String listeJeux;
    private String listePlats;
    private String listeParams;
    private String listeCapts;
    private String listeCoords;
    private String listeDates;

    public ArrayList<Plateforme> getPlateformes()
    {
        return plateformes;
    }

    public void setPlateformes( ArrayList<Plateforme> plateformes )
    {
        this.plateformes = plateformes;
    }

    public String[] getSelectPlats()
    {
        return selectPlats;
    }

    public void setSelectPlats( String[] selectPlats )
    {
        this.selectPlats = selectPlats;
    }

    public int getNbSelectedPlats()
    {
        if( selectPlats == null )
            return 0;
        return selectPlats.length;
    }

    public ArrayList<Jeu> getJeux()
    {
        return jeux;
    }

    public void setJeux( ArrayList<Jeu> jeux )
    {
        this.jeux = jeux;
    }

    public int getNbSelectedJeux()
    {
        if( selectJeux == null )
            return 0;
        return selectJeux.length;
    }

    public String[] getSelectJeux()
    {
        return selectJeux;
    }

    public void setSelectJeux( String[] selectJeux )
    {
        this.selectJeux = selectJeux;
    }

    public ArrayList<Capteur> getCapteurs()
    {
        return capteurs;
    }

    public void setCapteurs( ArrayList<Capteur> capteurs )
    {
        this.capteurs = capteurs;
    }

    public String[] getSelectCapts()
    {
        return selectCapts;
    }

    public void setSelectCapts( String[] selectCapts )
    {
        this.selectCapts = selectCapts;
    }

    public int getNbSelectedCapts()
    {
        if( selectCapts == null )
            return 0;
        return selectCapts.length;
    }

    public ArrayList<Parametre> getParametres()
    {
        return parametres;
    }

    public void setParametres( ArrayList<Parametre> parametres )
    {
        this.parametres = parametres;
    }

    public String[] getSelectParams()
    {
        return selectParams;
    }

    public void setSelectParams( String[] selectParams )
    {
        this.selectParams = selectParams;
    }

    public int getNbSelectedParams()
    {
        if( selectParams == null )
            return 0;
        return selectParams.length;
    }

    public String getDateDeb()
    {
        return dateDeb;
    }

    public void setDateDeb( String dateDeb )
    {
        this.dateDeb = dateDeb;
    }

    public String getDateFin()
    {
        return dateFin;
    }

    public void setDateFin( String dateFin )
    {
        this.dateFin = dateFin;
    }

    public String getLatMin()
    {
        return latMin;
    }

    public void setLatMin( String latMin )
    {
        this.latMin = latMin;
    }

    public String getLatMax()
    {
        return latMax;
    }

    public void setLatMax( String latMax )
    {
        this.latMax = latMax;
    }

    public String getLonMin()
    {
        return lonMin;
    }

    public void setLonMin( String lonMin )
    {
        this.lonMin = lonMin;
    }

    public String getLonMax()
    {
        return lonMax;
    }

    public void setLonMax( String lonMax )
    {
        this.lonMax = lonMax;
    }

    public int getNbValeurs()
    {
        return nbValeurs;
    }

    public void setNbValeurs( int nbValeurs )
    {
        this.nbValeurs = nbValeurs;
    }

    public void reset( ActionMapping mapping, HttpServletRequest request )
    {
        selectPlats = new String[0];
        selectJeux = new String[0];
        selectCapts = new String[0];
        selectParams = new String[0];
        latMin = latMinInit;
        latMax = latMaxInit;
        lonMin = lonMinInit;
        lonMax = lonMaxInit;
        dateDeb = dateDebInit;
        dateFin = dateFinInit;
        super.reset( mapping, request );
    }

    public ActionErrors validate( ActionMapping arg0, HttpServletRequest arg1 )
    {
        ActionErrors errors = new ActionErrors();
        Personne pers = (Personne) arg1.getSession().getAttribute( "SES_USER" );
        if( pers == null )
        {
            errors.add( "dateFin", new ActionError( "errors.access.login" ) );
            return errors;
        }
        // Lat/Lon
        if( !Nombre.isDoubleInInterval( latMin, -90, 90 ) || !Nombre.isDoubleInInterval( latMax, -90, 90 ) )
        {
            errors.add(/* ActionErrors.GLOBAL_MESSAGE */"latMax", new ActionError( "errors.upload.updateMetadata.failed.lat" ) );
        }
        else if( Double.parseDouble( latMin ) > Double.parseDouble( latMax ) )
        {
            errors.add( "latMax", new ActionError( "errors.upload.updateMetadata.failed.latbound" ) );
        }
        if( !Nombre.isDoubleInInterval( lonMin, -180, 180 ) || !Nombre.isDoubleInInterval( lonMax, -180, 180 ) )
        {
            errors.add( "lonMax", new ActionError( "errors.upload.updateMetadata.failed.lon" ) );
        }
        else if( Double.parseDouble( lonMin ) > Double.parseDouble( lonMax ) )
        {
            errors.add( "lonMax", new ActionError( "errors.upload.updateMetadata.failed.lonbound" ) );
        }
        if( !DateTime.isDateFr( dateDeb ) || !DateTime.isDateFr( dateFin ) )
        {
            errors.add( "dateFin", new ActionError( "errors.access.date" ) );
        }
        else if( DateTime.plusGrand( dateDeb, dateFin ) )
        {
            errors.add( "dateFin", new ActionError( "errors.access.date.bigger" ) );
        }
        if( nbValeurs == 0 )
        {
            if( ( selectCapts == null || selectCapts.length == 0 ) &&
                    ( selectJeux == null || selectJeux.length == 0 ) &&
                    ( selectParams == null || selectParams.length == 0 ) &&
                    ( selectPlats == null || selectPlats.length == 0 ) )
            {
                errors.add( "dateFin", new ActionError( "errors.access.failed.sel" ) );
            }
        }
        return errors;
    }

    public String getOutput()
    {
        return output;
    }

    public void setOutput( String output )
    {
        this.output = output;
    }

    public String getCompression()
    {
        return compression;
    }

    public void setCompression( String compression )
    {
        this.compression = compression;
    }

    public String getDateDebInit()
    {
        return dateDebInit;
    }

    public void setDateDebInit( String dateDebInit )
    {
        this.dateDebInit = dateDebInit;
    }

    public String getDateFinInit()
    {
        return dateFinInit;
    }

    public void setDateFinInit( String dateFinInit )
    {
        this.dateFinInit = dateFinInit;
    }

    public String getLatMinInit()
    {
        return latMinInit;
    }

    public void setLatMinInit( String latMinInit )
    {
        this.latMinInit = latMinInit;
    }

    public String getLatMaxInit()
    {
        return latMaxInit;
    }

    public void setLatMaxInit( String latMaxInit )
    {
        this.latMaxInit = latMaxInit;
    }

    public String getLonMinInit()
    {
        return lonMinInit;
    }

    public void setLonMinInit( String lonMinInit )
    {
        this.lonMinInit = lonMinInit;
    }

    public String getLonMaxInit()
    {
        return lonMaxInit;
    }

    public void setLonMaxInit( String lonMaxInit )
    {
        this.lonMaxInit = lonMaxInit;
    }

    public String getListeJeux()
    {
        return listeJeux;
    }

    public void setListeJeux( String listeJeux )
    {
        this.listeJeux = listeJeux;
    }

    public String getListePlats()
    {
        return listePlats;
    }

    public void setListePlats( String listePlats )
    {
        this.listePlats = listePlats;
    }

    public String getListeParams()
    {
        return listeParams;
    }

    public void setListeParams( String listeParams )
    {
        this.listeParams = listeParams;
    }

    public String getListeCapts()
    {
        return listeCapts;
    }

    public void setListeCapts( String listeCapts )
    {
        this.listeCapts = listeCapts;
    }

    public String getListeCoords()
    {
        return listeCoords;
    }

    public void setListeCoords( String listeCoords )
    {
        this.listeCoords = listeCoords;
    }

    public String getListeDates()
    {
        return listeDates;
    }

    public void setListeDates( String listeDates )
    {
        this.listeDates = listeDates;
    }
}